--ModuleOptions box
--*********************

function ShowModuleOption()
	--If the option box is already open, close it.
	if ModuleOption~=nil then if ModuleOption.Window~=nil then ModuleOption.Window:Close() end end


	ModuleOption={}
	local PlayerClass=Player:GetClass()

	--Make the window	
	ModuleOption.Window = Turbine.UI.Lotro.Window()
	ModuleOption.Window:SetPosition( 100,100 )

	ModuleOption.Window:SetText( "Which Modules to Load?")
	ModuleOption.Window:SetVisible( true )
	ModuleOption.Window:SetZOrder(1000)

	--Master listbox
	--****************
	ModuleOption.ListBox = Turbine.UI.ListBox()
		ModuleOption.ListBox:SetParent( ModuleOption.Window )
		ModuleOption.ListBox:SetPosition( 20, 40 )
		ModuleOption.ListBox:SetSize( 320, 1024)
		--ModuleOption.ListBox:SetMaxItemsPerLine(1)
		ModuleOption.ListBox:SetMaxColumns(1)
		ModuleOption.ListBox:SetOrientation( Turbine.UI.Orientation.Horizontal )

	ModuleOption.ListBox:AddItem(optionlabel(320,"Select which modules to load.",true))

	Modulefader=ModuleCheckbox(Modules.fader,"Fader module",
	function( sender, args )
		Modules.fader=Modulefader:IsChecked()
		if Modules.fader then import "JackdawPlugins.Bevy2.fader" initialisefader() end
	end)

	Modulestance=ModuleCheckbox(Modules.stance,"Stance module",
	function( sender, args )
		Modules.stance=Modulestance:IsChecked()
		if Modules.stance then import "JackdawPlugins.Bevy2.stance" initialisestance() end
	end) 

	Modulehider=ModuleCheckbox(Modules.hider~=nil,"HiderBar module",
	function( sender, args )
		Modules.hider=Modulehider:IsChecked()
		if Modules.hider then import "JackdawPlugins.Bevy2.hider" else Modules.hider=nil end
	end) 

	if PlayerClass==193 then Modulerunekeeper=ModuleCheckbox(Modules.runekeeper,"Runekeeper Attunement module",
	function( sender, args )
		Modules.runekeeper=Modulerunekeeper:IsChecked()
		if Modules.runekeeper then import "JackdawPlugins.Bevy2.runekeeper"  else Proc=false end
	end) end

	if PlayerClass==24 then Modulecaptain=ModuleCheckbox(Modules.captain,"Captain module",
	function( sender, args )
		Modules.captain=Modulecaptain:IsChecked()
		if Modules.captain then import "JackdawPlugins.Bevy2.captain"  else Proc=false end
	end) end

	if PlayerClass==23 then Moduleguardian=ModuleCheckbox(Modules.guardian,"Guardian module", 
	function( sender, args )
		Modules.guardian=Moduleguardian:IsChecked()
		if Modules.guardian then import "JackdawPlugins.Bevy2.guardian"  else Proc=false end
	end) end

	if PlayerClass==172 then Modulechampion=ModuleCheckbox(Modules.champion,"Champion module", 
	function( sender, args )
		Modules.champion=Modulechampion:IsChecked()
		if Modules.champion then import "JackdawPlugins.Bevy2.champion"  else Proc=false end
	end) end

	if PlayerClass==40 then Moduleburglar=ModuleCheckbox(Modules.burglar,"Burglar module", 
	function( sender, args )
		Modules.burglar=Moduleburglar:IsChecked()
		if Modules.burglar then import "JackdawPlugins.Bevy2.Burglar"  else Proc=false end
	end) end

	if PlayerClass==162 then Modulehunter=ModuleCheckbox(Modules.hunter,"Hunter module", 
	function( sender, args )
		Modules.hunter=Modulehunter:IsChecked()
		if Modules.hunter then import "JackdawPlugins.Bevy2.hunter"  else Proc=false end
	end) end

	Modulepopups=ModuleCheckbox(Modules.popups,"Pop-Up bars module",
	function( sender, args )
		if Modules.popups then OpenAllPops() end
		Modules.popups=Modulepopups:IsChecked()	
		if Modules.popups then import "JackdawPlugins.Bevy2.popups" initialisepopups() end	
		end)
		
	if PlayerClass==31 then Moduleminstrel=ModuleCheckbox(Modules.minstrel,"Minstrel module", 
	function( sender, args )
		Modules.minstrel=Moduleminstrel:IsChecked()
		if Modules.minstrel then import "JackdawPlugins.Bevy2.Minstrel"  else Proc=false end
	end) end

	ModuleLPM=ModuleCheckbox(Modules.LPM,"Low Power/Morale module",
	function( sender, args )
		Modules.LPM=ModuleLPM:IsChecked()
		if Modules.LPM then import "JackdawPlugins.Bevy2.LowPowerMorale" end
	end) 

	ModuleDebuff=ModuleCheckbox(Modules.Debuff,"Debuff module",
	function( sender, args )
		Modules.Debuff=ModuleDebuff:IsChecked()
		if Modules.Debuff then import "JackdawPlugins.Bevy2.Debuff" end
	end) 

	Moduleskin=ModuleCheckbox(Modules.skin,"Skin module",
	function( sender, args )
		Modules.skin=Moduleskin:IsChecked()
		if Modules.skin then import "JackdawPlugins.Bevy2.skin" end
	end) 
	
	ModuleMonitor=ModuleCheckbox(Modules.Monitor,"Buff Monitor Module",
	function( sender, args )
		Modules.Monitor=ModuleMonitor:IsChecked()
		if Modules.Monitor then import "JackdawPlugins.Bevy2.Monitor" end
	end) 
	
	ModuleCombat=ModuleCheckbox(Modules.Combat,"Show/Hide in Combat Module",
	function( sender, args )
		Modules.Combat=ModuleCombat:IsChecked()
		if Modules.Combat then import "JackdawPlugins.Bevy2.Combat" end
	end) 
	
	ModuleMount=ModuleCheckbox(Modules.Mount,"Show/Hide on Mount Module",
	function( sender, args )
		Modules.Mount=ModuleMount:IsChecked()
		if Modules.Mount then import "JackdawPlugins.Bevy2.Mount" end
	end) 
	
	ModuleLabel=ModuleCheckbox(Modules.label,"Label Module",
	function( sender, args )
		Modules.label=ModuleLabel:IsChecked()
		if Modules.label then import "JackdawPlugins.Bevy2.Label" end
	end) 
	
	ModuleStore=ModuleCheckbox(Modules.Store,"Store Build Module",
	function( sender, args )
		if Modules.Store then Turbine.Shell.WriteLine("Be careful when disabling this module - may cause errors on re-enable.") end
		Modules.Store=ModuleStore:IsChecked()
		if Modules.Store then 
			import "JackdawPlugins.Bevy2.BarStore"
		end
	end) 
	
	ModuleKeyModifiers=ModuleCheckbox(Modules.KeyModifiers,"Show/Hide on Key Modifiers Module",
	function( sender, args )
		Modules.KeyModifiers=ModuleKeyModifiers:IsChecked()
		if Modules.KeyModifiers then import "JackdawPlugins.Bevy2.KeyModifiers" end
	end) 
	
	ModuleOption.ListBox:AddItem(optionlabel(320,"Note that modules are not un-loaded",true))
	ModuleOption.ListBox:AddItem(optionlabel(320,"until the plugin is reset",true))
	--Finally, set the height of the option window by scanning all of the installed boxes.
	local height=60
	for i=1,ModuleOption.ListBox:GetItemCount() do
		height=height+ModuleOption.ListBox:GetItem(i):GetHeight()
	end
	ModuleOption.Window:SetSize(360,height)

	--An event! When the window closes, delete it from memory
	ModuleOption.Window.Closed=function(sender,args)
		ModuleOption=nil
		if Opt.Window~=nil then
			local t
			if Opt.Window:IsVisible() then
				Opt.Window:Close()
				t=true
			end
			Opt.Create()
			if t then Opt.Update() end
		end		
	end
end

ModuleCheckbox=class(Turbine.UI.Lotro.CheckBox)
 function ModuleCheckbox:Constructor(a,text,fn)
 Turbine.UI.Lotro.CheckBox.Constructor(self)
	self:SetChecked(a)
	self:SetText(text)
	self:SetSize(320,24)
	self.CheckedChanged = fn
	ModuleOption.ListBox:AddItem(self)
end
 
