--[[
		Bevy-O-Bars version 2
		
		Concept: 	Streamline the original bevy bars with better written functions, less mandatory events.
						Make additions optional, so the player can have simple or complex a plugin as they wish.
						Written by me, for me - I will serve my needs first.
			
		To Do:

		Remove NASTY HACK! from Stance when they fix the stances for Minstrels.
		Re-enable Burglar stances when they put them in the game.
		
		If I ever re-write this I am going to use tables of functions called from a central programme a lot more. It will make the core modules simpler, and allow the hooks to be much less complex.
		
		]]--

import "Turbine"
import "Turbine.UI";
import "Turbine.UI.Lotro";
import "Turbine.Gameplay";

local test=pcall(function() import "Deusdictum.UI.Dragbar" end)
if test==false then 

	Turbine.Shell.WriteLine("You *must* have Deusdictum's dragbar installed for Bevy to work! Get thee hence to Lotrointerface!") 
	Turbine.Shell.WriteLine("Not loading Bevy-o-bars!")
	
else

	if not pcall(function() import "JackdawPlugins.Patch.Patch" end) then 
		--Turbine.Shell.WriteLine("Patch not present - default Load and Save used")
		JackdawPlugins.Patch={}
		function JackdawPlugins.Patch.Load(a,b,c) return Turbine.PluginData.Load(a,b,c) end
		function JackdawPlugins.Patch.Save(a,b,c,d) Turbine.PluginData.Save(a,b,c,d) end
	end
	
	--New settings for the NewOption Module. This allows modules to add their options to the bar "painlessly"
		Opt={}
		Opt.Module={}
		Opt.Updaters={}

		--This is the list of values to check in the update module.
		--The name here MUST match the name of the Bar[i].Data."Value"
		--NINDYR Patch
		--Opt.source={"x","y","sx","sy","pad","gap","size","lock","opacity"}
		Opt.source={"x","y","sx","sy","gap","size","lock","opacity","padl","padr","padt","padb"}
		--Must list boolean values seperately. This includes tables that have a boolean component.
		Opt.bool={lock=true}
		Opt.table={}
		
	--Context menu functions
		Context={}
	
	--Imports
	import "JackdawPlugins.Bevy2.class"
	import "JackdawPlugins.Bevy2.snapper"
	import "JackdawPlugins.Bevy2.function"
	import "JackdawPlugins.Bevy2.OptionPanel"

	Load()
	import "JackdawPlugins.Bevy2.NewOption"	
	Plugins["BevyOBars2"].Unload = function( sender, args )
		Save()
	end	
end